Bug 632874 - Review Request: freedup - Links substantially identical, duplicate files to save file system space
Review Request: freedup - Links substantially identical, duplicate files to s...
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Randall "Randy" Berry
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-DEADREVIEW
  Show dependency treegraph
 
Reported: 2010-09-11 12:37 EDT by David Riches
Modified: 2013-02-19 05:49 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-02-19 05:49:13 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description David Riches 2010-09-11 12:37:16 EDT
Spec URL: http://dcr226.fedorapeople.org/SPECS/freedup.spec
SRPM URL: http://dcr226.fedorapeople.org/SRPMS/freedup-1.5-7.fc13.src.rpm
Description: Freedup eliminates duplicate files by linking them, and thus reduces the amount
of used disk space within one or more file systems. By default, hardlinks are
used on a single device, symbolic links when the devices differ. A set of
options allows you to modify the methods of file comparison, the hash functions,
the linking behavior, and the reporting style. You may use batch or interactive
mode. Freedup usually only considers identical files, but when comparing audio
or graphics files, you may elect to ignore the tags. Multimedia files often are
a good target for deduplication
Comment 1 Randall "Randy" Berry 2010-09-12 16:20:27 EDT
================================
Key:

[P] Pass
[F] Fail See [n]
[-] Not applicable
[?] Questions (see comments)

================================

[F]  MUST: rpmlint must be run on every package. The output should be
     posted in the review.

freedup.src: W: spelling-error %description -l en_US hardlinks -> hard links, hard-links, hardliners
freedup.src: W: spelling-error %description -l en_US deduplication -> reduplication, de duplication, de-duplication
freedup.i686: W: spelling-error %description -l en_US hardlinks -> hard links, hard-links, hardliners
freedup.i686: W: spelling-error %description -l en_US deduplication -> reduplication, de duplication, de-duplication

      In some cases spelling errors could be ignored these should
      be corrected. 

freedup.i686: W: spurious-executable-perm /usr/share/doc/freedup-1.5/verify
freedup.i686: W: spurious-executable-perm /usr/share/doc/freedup-1.5/demo/mp4/utf8.m4a
freedup.i686: W: spurious-executable-perm /usr/share/doc/freedup-1.5/demo/mp4/base.m4a
freedup.i686: W: spurious-executable-perm /usr/share/man/man1/freedup.1.gz

     Must be fixed

freedup.i686: W: file-not-utf8 /usr/share/doc/freedup-1.5/README
     
     Must be fixed.

freedup.i686: W: doc-file-dependency /usr/share/doc/freedup-1.5/verify /usr/bin/make

     Must be fixed.

freedup-debuginfo.i686: E: empty-debuginfo-package

     Must be fixed.

[P]  MUST: The package must be named according to the Package Naming
     Guidelines.

[P]  MUST: The spec file name must match the base package %{name},
     in the format %{name}.spec unless your package has an exemption.

[F]  MUST: The package must meet the Packaging Guidelines.

     The source and resulting RPM contain mp3 and m4a files located
     in the following directories: /demo/mp3/ and /demo/mp4/

[?]  MUST: The package must be licensed with a Fedora approved
     license and meet the Licensing Guidelines.

[?]  MUST: The License field in the package spec file must match
     the actual license.

     GPL+ Also hints to contain BSD source.

[?]  MUST: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of
     the license(s) for the package must be included in %doc.

     COPYING file is very vague. Claims GPL without version.
     Also hints to contain BSD source

[P]  MUST: The spec file must be written in American English.

[P]  MUST: The spec file for the package MUST be legible.

[P]  MUST: The sources used to build the package must match the upstream
     source, as provided in the spec URL. Reviewers should use md5sum for
     this task. If no upstream URL can be specified for this package,
     please see the Source URL Guidelines for how to deal with this.

      d1b2658c0dac02687c64be28c80a3605  freedup-1.5-3-src.tar.bz2
      d1b2658c0dac02687c64be28c80a3605  freedup-1.5-3-src.tar.bz2.2

[P]  MUST: The package MUST successfully compile and build into binary
     rpms on at least one primary architecture.

     http://koji.fedoraproject.org/koji/taskinfo?taskID=2463284

[-]  MUST: If the package does not successfully compile, build or work on
     an architecture, then those architectures should be listed in the spec
     in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug
     filed in bugzilla, describing the reason that the package does not
     compile/build/work on that architecture. The bug number MUST be
     placed in a comment, next to the corresponding ExcludeArch line.

[P]  MUST: All build dependencies must be listed in BuildRequires,
     except for any that are listed in the exceptions section of the
     Packaging Guidelines ; inclusion of those as BuildRequires is
     optional. Apply common sense.

[-]  MUST: The spec file MUST handle locales properly. This is done by
     using the %find_lang macro. Using %{_datadir}/locale/[ ] is strictly
     forbidden.

[-]  MUST: Every binary RPM package (or sub package) which stores shared
     library files (not just symlinks) in any of the dynamic linker's
     default paths, must call ldconfig in %post and %postun.

[-]  MUST: If the package is designed to be relocatable, the packager
     must state this fact in the request for review, along with the
     rationalization for relocation of that specific package.
     Without this, use of Prefix: /usr is considered a blocker.

[P]  MUST: A package must own all directories that it creates. If it does not
     create a directory that it uses, then it should require a package which
     does create that directory. Refer to the Guidelines for examples.

[P]  MUST: A package must not contain any duplicate files in the %files
     listing.

[?]  MUST: Permissions on files must be set properly. Executables should
     be set with executable permissions, for example. Every %files section
     must include a %defattr(...) line.

    %defattr(-,root,root) should be %defattr(-,root,root,-)

[?]  MUST: The %clean section is not required for F-13 and above. Each package
     for F-12 and below (or EPEL) MUST have a %clean section, which contains
     rm -rf %{buildroot} (or $RPM_BUILD_ROOT).

     Do you plan on building this for EPEL or F12? If not all
     rm -rf $RPM_BUILD_ROOT can be removed.

[F]  MUST: Each package must consistently use macros, as described in the
     macros section of Packaging Guidelines.

     macrofy /usr/bin/freedup should be %{_bindir}/%{name}

[P]  MUST: The package must contain code, or permissible content.
     This is described in detail in the code vs. content section
     of Packaging Guidelines.

[-]  MUST: Large documentation files should go in a -doc sub package.
     (The definition of large is left up to the packager's best judgement,
     but is not restricted to size. Large can refer to either size or quantity)

[F]  MUST: If a package includes something as %doc, it must not affect the
     runtime of the application. To summarize: If it is in %doc, the program
     must run properly if it is not present.

     freedup.i686: W: doc-file-dependency /usr/share/doc/freedup-1.5/verify
     /usr/bin/make

[-]  MUST: Header files must be in a -devel package.

[-]  MUST: Static libraries must be in a -static package.

[-]  MUST: Packages containing pkgconfig(.pc) files must 'Requires:
     pkgconfig' (for directory ownership and usability).

[-]  MUST: If a package contains library files with a suffix
     (e.g. libfoo.so.1.1), then library files that end in .so
     (without suffix) must go in a -devel package.

[-]  MUST: In the vast majority of cases, devel packages must require
     the base package using a fully versioned dependency: Requires:
     %{name} = %{version}-%{release}

[-]  MUST: Packages must NOT contain any .la libtool archives,
     these should be removed in the spec.

[-]  MUST: Packages containing GUI applications must include a
     %{name}.desktop file,and that file must be properly installed
     with desktop-file-install in the %install section. This is described
     in detail in the desktop files section of the Packaging Guidelines.
     If you feel that your packaged GUI application does not need a .desktop
     file, you must put a comment in the spec file with your explanation.

[P]  MUST: Packages must not own files or directories already owned by
     other packages. The rule of thumb here is that the first package
     to be installed should own the files or directories that other packages
     may rely upon. This means, for example, that no package in Fedora should
     ever share ownership with any of the files or directories owned by the
     file system or man package. If you feel that you have a good reason to
     own a file or directory that another package owns, then please present
     that at package review time.

[?]  MUST: At the beginning of %install, each package MUST run
     rm -rf %{buildroot} ( or $RPM_BUILD_ROOT ). (For F12, EPEL Only)

[F]  MUST: All file names in rpm packages must be valid UTF-8.

     freedup.i686: W: file-not-utf8 /usr/share/doc/freedup-1.5/README

SHOULD Items:

[P]  Should build in mock.
[ ]  Should build on all supported archs
[-]  Should function as described.
[-]  Should have sane scriptlets.
[-]  Should have sub packages require base package with fully versioned depend.
[P]  Should have dist tag
[P]  Should package latest version
[P]  Check for outstanding bugs on package. (For core merge reviews)
Comment 2 David Riches 2010-09-12 20:02:36 EDT
Thanks very much for the review.

I've made the relevant changes - rpmlint doesn't report anything for me now.

Dave
Comment 3 David Riches 2011-03-13 15:07:40 EDT
Finally all fixed:


http://dcr226.fedorapeople.org/SRPMS/freedup-1.5-8.fc14.src.rpm
http://dcr226.fedorapeople.org/SPECS/freedup.spec

rpmlint reports no errors

f13 koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=2909167
f14 koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=2909174
f15 koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=2909180


[david@drlaptop SPECS]$ rpmlint ../RPMS/i686/freedup-debuginfo-1.5-8.fc14.i686.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.


[david@drlaptop SPECS]$ rpmlint ../RPMS/i686/freedup-1.5-8.fc14.i686.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[david@drlaptop SPECS]$ 


[david@drlaptop SPECS]$ rpmlint ../SRPMS/freedup-1.5-8.fc14.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[david@drlaptop SPECS]$
Comment 4 Jon Ciesla 2011-03-30 11:36:57 EDT
The GPL+ tag is OK if that's what's really the case.

WRT the patent-encumbered media files, they are expressly forbidden:

https://fedoraproject.org/wiki/Packaging/Guidelines#Code_Vs_Content

Remove and build from a modified tarball to prevent redistribution in the SRPM:

https://fedoraproject.org/wiki/Packaging:SourceURL#When_Upstream_uses_Prohibited_Code
Comment 5 Miroslav Suchý 2012-12-16 08:01:48 EST
Ping? Any progress here? Or we can close this review?
Comment 6 Miroslav Suchý 2013-02-19 05:49:13 EST
Stalled Review. Closing per:
https://fedoraproject.org/wiki/Policy_for_stalled_package_reviews
If you ever want to continue with this review, please reopen or
submit new review.

Note You need to log in before you can comment on or make changes to this bug.